#version 130
precision mediump float;

// the dynamic shader for the player's figure to carry out rotation+translation on hardware
uniform mat4 perspective;
uniform mat4 view;
uniform mat4 tex_mat; 

// model transform (initial up translation + rotation + final translation)
uniform mat4 model;

// SHADOW MAPPING
uniform mat4 lightperspective;

// VERTEX
in vec4 vertex;
in vec3 normal;
in vec2 color; // actually texture

// OUTPUT
out vec3 world_normal;
out vec4 world_position;
out vec2 vTexCoord;
out vec4 SM_tex_coord;

void main() {
 vTexCoord = color;
 vec4 normal4 = vec4(normal, 0.0f);
 world_normal = (model * normal4).xyz;
 world_position = model * vertex;
 gl_Position = perspective * view * model * vertex;
 SM_tex_coord = tex_mat * model * vertex;
}